/* DisplayPersonsByNameStatus.java
 */

/* DisplayPersonsByNameStatus
 * 2:ύXNX
 */
public class DisplayPersonsByNameStatus extends ConsoleStatus {

	// tB[h
	private String name;
	private PersonList plist;
	private PersonList selectedList;
	private DisplayPersonStatus next;

	// 2:ǉ
	// Xg\͈͂̐擪ʒuil0j
	private int startIdx;

	/**
	 * RXgN^ DisplayPersonsByNameStatus
	 * @param String firstMess
	 * @param String promptMess
	 * @param boolean IsEndStatus
	 * @param PersonList plist
	 * @param DisplayPersonStatus next
	 */
	DisplayPersonsByNameStatus( String firstMess, String promptMess,
	                     boolean IsEndStatus,
	                     PersonList plist, DisplayPersonStatus next ) {
		super( firstMess, promptMess, IsEndStatus );
		this.name = "";
		this.plist = plist;
		this.selectedList = null;
		this.next = next;
		// 2:ǉ
		this.startIdx = 0;
	}

	// ŏɏo͂郁bZ[W\
	/** displayFirstMess
	 * @throws Exception
	 */
	public void displayFirstMess() throws Exception {
		displayList();
		super.displayFirstMess();
	}

	// 鎁o^
	/** setName
	 * @param String name
	 */
	public void setName( String name ) {
		this.name = name;
		// 2:ǉ
		startIdx = 0;
	}

	// ͂ꂽ̕Ɋ܂ޏ]ƈ̃R[h
	// o
	/**
	 * displayList
	 */
	public void displayList() {
		// 2:ǉ
		Person p;

		// ͂ꂽɈv܂͎܂ޏ]ƈ̃R[h
		// selectedListɎo
		selectedList = plist.searchByName( name );
		// selectedLisť0ȂΓYE
		// ]ƈ͂Ȃƕ\
		if( selectedList.size() <= 0 )
			System.out.println( "]ƈ݂܂B" );
		// 2:ύX
		// Xg\͈͂̐擪ʒu
		// 擪ʒu{2̈ʒũR[h܂ł\
		// (Xg̖ɒBƂ͖̃R[h܂ł\)
		else {
			for( int i = startIdx;
			     i < (startIdx + 3) && i < selectedList.size(); i++ ) {
				p = (Person)selectedList.getRecord( i );
				System.out.println( p.toString() );
			}
		}
	}

	// ̏ԂɑJڂ邱Ƃ𑣂߂̃bZ[W̕\
	/** getNextStatus
	 * @param String s
	 * @return ConsoleStatus
	 */
	public ConsoleStatus getNextStatus( String s ) {
		// l͂ꂽꍇC̐lƓID
		// R[hselectedListɂ邩ǂ肵C
		// ΂̏DisplayPersonStatusɓn
		try {
			int i = Integer.parseInt( s );
			Person p = selectedList.get( i );
			if( p == null )
				return this;
			else {
				next.setPersonRecord( p );
				return next;
			}
		} catch( NumberFormatException e ) {
			// 2:ύX
			// "N"͂ꂽꍇ:
			// Xg\͈͂̐擪ʒu3Z
			// C3ZlXg̑傫𒴂ꍇ
			// 擪ʒu0ɖ߂
			if( s.equals("N") ) {
				if( (startIdx + 3) < selectedList.size() )
					startIdx += 3;
				else
					startIdx = 0;
			}
			// "P"͂ꂽꍇ:
			// Xg\͈͂̐擪ʒu3Z
			// C3Zl}CiXɂȂꍇ
			// Xg̑傫|3̈ʒuɂ
			if( s.equals("P") ) {
				if( (startIdx - 3) < 0 )
					startIdx = (selectedList.size() - 3) < 0 ? 0 : selectedList.size() - 3;
				else
					startIdx -= 3;
			}

			return super.getNextStatus( s );
		}
	}
}
